<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Traits;

trait AutocompleteRepositoryTrait
{
    public function findByPhrase(string $phrase, string $locale)
    {
        $expr = $this->getEntityManager()->getExpressionBuilder();

        return $this->createQueryBuilder('o')
            ->innerJoin('o.translations', 'translation', 'WITH', 'translation.locale = :locale')
            ->andWhere($expr->orX(
                'translation.name LIKE :phrase',
                'o.code LIKE :phrase'
            ))
            ->setParameter('phrase', '%' . $phrase . '%')
            ->setParameter('locale', $locale)
            ->getQuery()
            ->getResult();
    }

    public function findOneForInit($id)
    {
        return $this->createQueryBuilder('o')
            ->andWhere('o.id = :id')
            ->setParameter('id', (int) $id)
            ->getQuery()
            ->getResult();
    }
}
